#include "frecuUsb1.h"


#byte puerto_a=0x05
#byte puerto_b=0x06
#byte TRISA=0x85
#byte TRISB=0x86
#byte TMR0=1
#byte OPTION_REG=0x81
#byte INTE=0x0B
#byte STATUS=3


#byte T1CON=0x10
#byte TMR1L=0x0E
#byte TMR1H=0x0F
#byte PIR1=0x0C


unsigned char numero;
unsigned char numero2;
unsigned char numero3;
unsigned int16 retardo;
unsigned int16 retardo2;
//unsigned char contador2;

unsigned char error1;

// Se pone para que no modifique el ensamblador
#OPT 0



//100->1ms    50000->500ms   Sobre reloj de 4mhz
void delay_seta4(int16 dz)
{
   while(dz)
      {
         dz--;      
      }
}

void delay_seta(int16 dz)
{
  delay_seta4(dz);
  delay_seta4(dz);
  delay_seta4(dz);
  delay_seta4(dz);
  
}


void frecu9c()
{
   unsigned char z;
      puerto_b=puerto_b | 128;
      z=T1CON ;   //| 1;   //memoriza T1CON
      T1CON=z & 254; // pone a cero TMR1ON Desactiva contador
      PIR1=PIR1&254; //Borra rebase
      error1=0;      //Borra error
      TMR1L=0;
      TMR1H=0;
      T1CON=z & 255; // pone a uno TMR1ON activa contador
      delay_seta(retardo);
      delay_seta(retardo2);
      T1CON=z & 254; // pone a cero TMR1ON Desactiva contador
      puerto_b=puerto_b & 127;
     
      numero=TMR1L;
      numero2=TMR1H;
      numero3=0;
      if(PIR1&1) error1=1;
      PIR1=PIR1&254; //Borra rebase
}


void main()
{

 unsigned int32 xx;
 unsigned char escala,multipli;
 
     puerto_b=0;
     puerto_a=0;
   
//Puerto B como salida, el RB6 entrada de frecuencia
     TRISB=0x40;
//Puerto A como entrada 
     TRISA=0xff;

      printf ("\fFRECUENCIMETRO\nSETA43");
 
      T1CON=0b00000111;
      escala=0;
 
 while(true)
 {  
      retardo=100;
      retardo2=0;
      T1CON=0b00110111;
      frecu9c();
      xx=numero2*256;
      xx+=numero;
      
      escala=0;
      if(xx>7) escala=1;
      if(xx>82) escala=2;      
      if(xx>824) escala=3;
//      printf("%u  %u  xx1=%Lu  Escala=%d\n\r",numero2,numero,xx,escala);
      
      switch(escala)
             {
               case 0:
                  retardo=50000;
                  retardo2=50000;
                  T1CON=0b00000111;
                  multipli=1;
                  break;
               case 1:            
                  retardo=4997;
                  retardo2=5000;
                  T1CON=0b00000111;
                  multipli=10;
                  break;
               case 2:
                  retardo=3997;
                  retardo2=4000;
                  T1CON=0b00110111;
                  multipli=1;
                  break;
               case 3:
                  retardo=397;
                  retardo2=400;
                  T1CON=0b00110111;
                  multipli=1;
                  break;                  
            }             
      

      delay_seta(10000);
      frecu9c();

      xx=numero2;
      xx*=256;
      xx+=numero;      
      xx*=multipli;     
        printf("-->%u   %u    xx1=%Lu  Escala=%d\n\r",numero2,numero,xx,escala);
      
      if(error1==1)
         {
          printf(" Error escala   ");
         }
         else
         {
      
          switch(escala)      
              {              
               case 2:
                  xx=xx/10;                
                  printf("%09Lu KHz\n\r",xx);
                  break;;
               case 3:
                  printf("%09Lu KHz\n\r",xx);
                  break;  
               default:
                  printf("%09Lu Hz\n\r",xx);
            }       
         }
              
 //     delay_seta(10000);
 }

}
